<?php
/*
Plugin Name: PingPress.fm
Plugin URI: http://www.soldoutactivist.com/project-pingpressfm
Description: Allows you to spread your wonderful blog to 10+ social networks via <a href="http://ping.fm">ping.fm</a>
Version: 2.1.2
Author: Sold Out Activist
Author URI: http://www.soldoutactivist.com

Utilizes PHPingFM for API calls, http://phpingfm.dmitrizone.com/
*/

/***********************************************************************
 * Copyright (c) 2008 Sold Out Activist, http://www.soldoutactivist.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 ***********************************************************************/

function pingpressfm2_install() {
	global $wpdb;

	$pingpressfm2_db_version = '1.0';

	// create options
	add_option('pingpressfm2_firsttime', 1, '', 'no');
	update_option('pingpressfm2_firsttime', 1);
	add_option('pingpressfm2_options_updated', 0, '', 'no');
	update_option('pingpresfm2_options_updated', 0);
	add_option('pingpressfm2_post_published', 0, '', 'no');
	update_option('pingpressfm2_post_published', 0);
	add_option('pingpressfm2_verified', 0, '', 'no');
	update_option('pingpressfm2_verified', 0);
	add_option('pingpressfm2_reverify', 0, '', 'no');
	update_option('pingpressfm2_reverify', 0);
	add_option('pingpressfm2_test', 0, '', 'no');
	update_option('pingpressfm2_test', 0);

	add_option('pingpressfm2_api_dev', 'ee001e6b5e35f5a8b57cbca3126632db', '', 'no');
	update_option('pingprssfm2_api_dev', 'ee001e6b5e35f5a8b57cbca3126632db');

	add_option('pingpressfm2_api_user', '', '', 'no');
	add_option('pingpressfm2_update_microblog', 1, '', 'no');
	add_option('pingpressfm2_update_status', 1, '', 'no');
	add_option('pingpressfm2_update_blog', 1, '', 'no' );
	add_option('pingpressfm2_microblog_format', 'Blog Post: $title $slink', '', 'no');
	add_option('pingpressfm2_status_format', 'Blog Post: $title $slink', '', 'no');
	add_option('pingpressfm2_blog_format', '$post (<a href="$link">continue reading &aquo;</a>)', '', 'no');
	add_option('pingpressfm2_blog_truncate', '', '', 'no');
	add_option('pingpressfm2_dotdotdot', '...', '', 'no');

	add_option('pingpressfm2_test_title', 'This is a test title of +2', '', 'no');
	add_option('pingpressfm2_test_post', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nunc enim turpis, ultrices id, ultricies sed, cursus ut, arcu. Pellentesque aliquet dictum ligula. Proin ut nulla non justo molestie vulputate. Ut quam. Donec dictum velit eget est mattis convallis. Etiam in sapien. Vestibulum libero. Curabitur cursus odio ac nulla. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Proin auctor. Praesent pharetra accumsan lacus. Quisque nibh. Aliquam congue rhoncus metus. Curabitur in erat. Duis arcu dui, fermentum eu, condimentum vitae, tempus eget, metus.

Nam et tellus. Aliquam erat volutpat. Nullam ullamcorper dui eu augue. Morbi nisi velit, fermentum vitae, facilisis eget, accumsan sit amet, ipsum. Vestibulum diam justo, ornare sed, auctor non, posuere ullamcorper, erat. Nunc enim arcu, feugiat at, egestas vitae, viverra at, augue. Aenean et nisi. In hac habitasse platea dictumst. Vestibulum eleifend justo in neque. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nunc rutrum. Proin in orci. Vivamus vehicula erat faucibus nisl.

Aenean convallis ultricies est. Maecenas eu magna sit amet purus imperdiet viverra. Nulla scelerisque interdum diam. Morbi purus nunc, commodo vitae, pellentesque pretium, ornare a, massa. Nam vitae lorem. Maecenas sed lorem. Vestibulum a nibh. Integer aliquet, mi non commodo laoreet, mauris nibh feugiat lacus, et facilisis ligula sem aliquam magna. Vivamus hendrerit neque sollicitudin nibh. In id risus et leo vestibulum consequat. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Praesent lectus. Nulla quam mauris, porttitor sed, fermentum vel, venenatis at, diam. Mauris convallis, ante mollis sollicitudin posuere, ante dui gravida sapien, sit amet tempor tortor dui vulputate ipsum. Suspendisse sem tortor, gravida nec, aliquam non, bibendum id, mi. Cras pharetra venenatis magna. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos.

Nullam in mauris. Maecenas porta lorem non nibh. Donec convallis fringilla odio. Donec faucibus luctus ligula. Cras non enim. Ut tristique consequat purus. Ut tempor. Aliquam nec ligula id neque ultricies dictum. Nam viverra dictum metus. Aliquam viverra, odio hendrerit dignissim elementum, sem erat lobortis justo, ac cursus erat nunc bibendum dui. Sed tincidunt, velit vitae euismod placerat, leo magna dignissim nisl, quis porta mauris turpis at ante. Etiam nulla.

Donec facilisis arcu fermentum sapien. Nullam eget felis. Vestibulum id metus. Phasellus viverra nunc vitae ipsum. In vel lectus. Nam commodo vulputate risus. Aliquam ullamcorper. Etiam nec nisl at ante hendrerit pharetra. Vivamus odio tellus, posuere eget, congue quis, tempus ut, nisl. Donec et justo ac erat porta mollis.', '', 'no');
	add_option('pingpressfm2_test_link', 'http://wwww.my-blog.com/this-is-a-test-title-of-2-nifty', '', 'no');

	add_option('pingpressfm2_db_version', $pingpressfm2_db_version, '', 'no');

	// add the database
	$table = $wpdb->prefix. 'pingpressfm2';
	$sql = 'CREATE TABLE `'. $table. '` (
						`id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
						`post_id` BIGINT UNSIGNED NOT NULL DEFAULT \'0\',
						`last_update` INT UNSIGNED NOT NULL DEFAULT \'0\',
						`ping_ids` TEXT NOT NULL, 
						PRIMARY KEY  (`id`)
					);';
	if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
}

function pingpressfm2_slink($link=false) {
	$s3nt_url = 'http://www.s3nt.com/robot/'. $link;

	$pingfm_curl = curl_init($s3nt_url);
	curl_setopt($pingfm_curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($pingfm_curl, CURLOPT_TIMEOUT, 30);
	$new_url = curl_exec($pingfm_curl);
	$pingfm_curl = curl_close($pingfm_curl);

	if (!preg_match('/^FAIL/i', $new_url) && $new_url)
		return trim($new_url);
	return $link;
}

function pingpressfm2_parser($format=false, $data=false, $truncate=0) {
	$truncate = $truncate + 0;

	$replacement = Array('slink' => '$link', 'link' => '$link', 'post' => '$post', 'title' => '$title');
	$format = trim(preg_replace('/ +/', ' ', $format));
	if ($truncate > 0) {
		$data['post'] = strip_tags($data['post']);
		$format = str_replace('$link', $data['link'], $format);
		$format = str_replace('$slink', $data['slink'], $format);

		$post_no_title = (!preg_match('/\$title/i', $format) && preg_match('/\$post/i', $format));

		if (preg_match('/\$title/i', $format)) {
			$length = $truncate - (strlen($format) - strlen('$title')- ((preg_match('/\$post/i', $format)) ? strlen('$post') : 0));
			$format = (strlen($data['title']) > $length) ? str_replace('$title', substr($data['title'], 0, $length - strlen($data['separator'])).$data['separator'], $format) : str_replace('$title', $data['title'], $format);
		}
		if (preg_match('/\$post/i', $format)) {
			$length = $truncate - (strlen($format) - strlen('$post'));
			if ($length > 0) {
				$format = (strlen($data['post']) > $length) ? str_replace('$post', substr($data['post'], 0, $length - strlen($data['separator'])).$data['separator'], $format) : str_replace('$post', $data['post'], $format);
			} else {
				$format = str_replace('$post', '', $format);
			}
		}
		$format = substr($format, 0, $truncate);
	} else {
		foreach ($replacement as $name => $replace) {
			$format = str_replace($replace, $data[$name], $format);
		}
	}
	$format = str_replace('\n', "\n", $format);
	$format = trim(preg_replace('/ +/', ' ', $format));
	return $format;
}

function pingpressfm2_call($type=false, $post_data=false) {
	if (!$type || !$post_data) return false;

	// do the deed with ping.fm
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_URL, 'http://api.ping.fm/v1/'. $type);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
	$output = curl_exec($ch);

	// smoke a cigarette afterwards?
	if (preg_match('/OK/', $output)) {
		preg_match('/\<transaction\>([a-z0-9]+)\<\/transaction\>/', $output, $match);
		$ping_id = addslashes(trim($match[1]));
		return $ping_id;

	// no, it wasn't that good
	} else {
		return false;
	}
}

function pingpressfm2_hook($postID) {
	global $wpdb, $tableposts;

	$result = mysql_query('SELECT `post_date`, `post_modified`, `post_title`, `post_content`, `post_name` FROM `'. $tableposts. '` WHERE `id` = \''. $postID. '\'');
	if ($result) {
		$row = mysql_fetch_assoc($result);

		if ($row['post_date'] == $row['post_modified']) {
			$api_key_dev = get_option('pingpressfm2_api_dev');
			$api_key_user = get_option('pingpressfm2_api_user');

			if (!$api_key_dev || !$api_key_user) return false;

			$link = get_permalink($postID);
			$slink = pingpressfm2_slink($link);

			$update_microblog = get_option('pingpressfm2_update_microblog');
			$update_status = get_option('pingpressfm2_update_status');
			$update_blog = get_option('pingpressfm2_update_blog');
			$blog_truncate = get_option('pingpressfm2_blog_truncate');
			$separator = get_option('pingpressfm2_dotdotdot');

			$data = Array('title' => $row['post_title'], 'post' => $row['post_content'], 'link' => $link, 'slink' => $slink, 'separator' => $separator);

			$output = Array();

			if ($update_microblog) {
				$mb_format = get_option('pingpressfm2_microblog_format');
				$mb_format = pingpressfm2_parser($mb_format, $data, 140);

		    // build postdata
				$post_data = Array(
					'api_key' => $api_key_dev,
					'user_app_key' => $api_key_user,
					'post_method' => 'microblog',
					'body' => $mb_format
				);

				$ping_id = pingpressfm2_call('user.post', $post_data);
				if ($ping_id) {
					$output[] = 'm:'. $ping_id. ':'. strtotime($row['post_date']);
				}			
			}

			if ($update_status) {
				$s_format = get_option('pingpressfm2_status_format');
				$s_format = pingpressfm2_parser($s_format, $data, 200);

				// build postdata
				$post_data = Array(
					'api_key' => $api_key_dev,
					'user_app_key' => $api_key_user,
					'post_method' => 'status',
					'body' => $s_format
				);

				$ping_fm = pingpressfm2_call('user.post', $post_data);
				if ($ping_id) {
					$output[] = 's:'. $ping_id. ':'. strtotime($row['post_date']);
				}
			}

			if ($update_blog) {
				$b_format = get_option('pingpressfm2_blog_format');
				$b_format = pingpressfm2_parser($b_format, $data, $blog_truncate);
				$b_title = trim(preg_replace('/ +/', ' ', $row['post_title']));

				// build postdata
				$post_data = Array(
					'api_key' => $api_key_dev,
					'user_app_key' => $api_key_user,
					'post_method' => 'blog',
					'title' => $b_title,
					'body' => $b_format
				);

				$ping_fm = pingpressfm2_call('user.post', $post_data);
				if ($ping_id) {
					$output[] = 'b:'. $ping_id. ':'. strtotime($row['post_date']);
				}
			}

			if ($output) {
				$update_q = 'INSERT INTO `'. $wpdb->prefix. 'pingpressfm2` (`post_id`, `last_update`, `ping_ids`) VALUES (\''. $postID. '\', \''. strtotime($row['post_date']). '\', \''. implode($output, ','). '\') ON DUPLICATE KEY UPDATE `ping_ids` = CONCAT(`ping_ids`, \',\', \''. implode($output, ','). '\')';
				mysql_query($update_q);
				update_option('pingpressfm2_post_published', $postID);
			}
		}
	}
}

function pingpressfm2_admin() {
	add_options_page('pingPressFM', 'pingPressFM', 1, 'pingPressFM2', 'pingpressfm2_menu');
}

function pingpressfm2_menu() {
	echo '
<form method="post" action="options.php">
	<div id="wpbody">
		<div class="wrap">
			', wp_nonce_field('update-options'), '
			<input type="hidden" name="pingpressfm2_options_updated" value="1" />
			<input type="hidden" name="action" value="update" />
			<input type="hidden" name="page_options" value="pingpressfm2_test_title,pingpressfm2_test_link,pingpressfm2_test_post,pingpressfm2_test,pingpressfm2_options_updated,pingpressfm2_reverify,pingpressfm2_update_microblog,pingpressfm2_update_status,pingpressfm2_update_blog,pingpressfm2_api_user,pingpressfm2_microblog_format,pingpressfm2_status_format,pingpressfm2_dotdotdot,pingpressfm2_blog_format,pingpressfm2_blog_truncate" />
			<h2>Ping.fm Account Information</h2>
			In order to function, you need a <a href="http://www.ping.fm">Ping.fm account</a>. If you don\'t have one, check their <a href="http://www.twitter.com/pingfm">twitter</a> for the latest beta invite code. You also need both a developer API key and a user API key. <a href="http://www.soldoutactivist.com/project-pingpressfm#why-003">How do I get my keys?</a>
			<table class="form-table">
				<tr valign="top">
					<th scope="row">
						Triggers<br />
						<small>
							(<a href="http://www.soldoutactivist.com/project-pingpressfm#why-001">Why doesn\'t this plugin let me select individual triggers?</a>)
						</small>
					</th>
					<td>
						<label><input type="checkbox" name="pingpressfm2_update_microblog" value="1"', ((get_option('pingpressfm2_update_microblog')) ? ' checked="checked" ' : ''), '/> Micro-blogs (@m)</label><br /> 
						<label><input type="checkbox" name="pingpressfm2_update_status" value="1"', ((get_option('pingpressfm2_update_status')) ? ' checked="checked" ' : ''), '/> Statuses (@s)</label><br />
						<label><input type="checkbox" name="pingpressfm2_update_blog" value="1"', ((get_option('pingpressfm2_update_blog')) ? ' checked="checked" ' : ''), '/> Blogs (@b)</label><br />
						<small>There is a <a href="http://www.soldoutactivist.com/project-pingpressfm#recommended">list</a> of Ping.fm <abbr title="Social Networks">sNetwork</abbr> settings that will help you use all three at the same time effectively.</small>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">
						API Keys<br />
						<small>(<a href="http://www.soldoutactivist.com/project-pingpressfm#why-003">How do I get my keys?</a>)</small>
					</th>
					<td>
						User API Key</strong><br />
						<input type="text" name="pingpressfm2_api_user" value="', get_option('pingpressfm2_api_user'), '" size="40" /><br /><br />

						<label><input type="checkbox" name="pingpressfm2_reverify" value="1" /> I have changed my API keys, reverify them, please!</label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">
						Micro-blog<br />
						<small>
							(ping truncated at 140 characters, no HTML)<br /><br />
							<strong>Service Examples:</strong> <a href="http://www.twitter.com">Twitter</a>
						</small>
					</th>
					<td>
						Format (for new pings)<br />
						<input type="text" name="pingpressfm2_microblog_format" value="', get_option('pingpressfm2_microblog_format'), '" size="40" /><br />
						<small>(Default: <em>New Blog Posts: $title $link</em>), variables: $title, $post, $slink, $link<br />
						When truncating total ping, $post will be chewed on before $title. $link and $prepend are never truncated.</small><br />
						<strong>Do not use more than one of any variables, you will not like the result.</strong>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">
						Status Updates<br />
						<small>
							(ping truncated at 200 characters, no HTML)<br /><br />

							<strong>Service Examples:</strong> <a href="http://www.facebook.com">Facebook<a/>, <a href="http://www.myspace.com">MySpace</a>
						</small>
					</th>
					<td>
						Format (for new pings)<br />
						<input type="text" name="pingpressfm2_status_format" value="', get_option('pingpressfm2_status_format'), '" size="40" /><br />
						<small>(Default: <em>New Blog Posts: $title $link</em>), variables: $title, $post, $slink, $link<br />
						When truncating total ping, $post will be chewed on before $title. $link and $prepend are never truncated.</small><br />
						<strong>Do not use more than one of any variables, you will not like the result.</strong>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">Truncate Text</th>
					<td>
						<input type="text" name="pingpressfm2_dotdotdot" value="', get_option('pingpressfm2_dotdotdot'), '" /><br />
						<small>(Default: <em>...</em>) Used if and when $title and/or $post is truncated, will be added to the end of the chopping variable</small>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row">
						Blog Updates<br />
						<small>
							(pings are not automatically truncated, HTMl is allowed on some <abbr title="Social Networks">sNetworks</abbr>)<br /><br />
							<strong>Service Examples:</strong> <a href="http://www.livejournal.com">Livejournal</a>, <a href="http://www.blogger.com">Blogger</a>
						</small>
					</th>
					<td>
						Format<br />
						<input type="text" name="pingpressfm2_blog_format" value="', htmlspecialchars(get_option('pingpressfm2_blog_format')), '" size="40" /><br />
						<small>(Default: <em>$post</em> (&lt;a href="$link"&gt;continue reading&amp;raquo;&lt;/a&gt;)), variables: $slink, $link, $title (the title will be sent, so you don\'t need this usually), $post, \n (which will be converted to a new line)</small><br /><br />

						Truncate ping at...<br />
						<input type="text" name="pingpressfm2_blog_truncate" value="', htmlspecialchars(get_option('pingpressfm2_blog_truncate')), '" size="40" /><br />
						<small>(Default: <em>350</em>) Leave blank to not truncate post, otherwise the ping will be truncated like a micro-blog/status ping. You probably want to set it to something high like 350+</small>
					</td>
				</tr>
				<tr>
					<th scope="row">
						Test Formats
					</th>
					<td>
						<label><input type="checkbox" name="pingpressfm2_test" value="1" /> I\'d like to test my new formats, please.</label><br />
						<small>This won\'t make a blog post, it will just show you on the next page what your post might like look.</small><br /><br />

						Test Title ($title)<br />
						<input type="text" name="pingpressfm2_test_title" value="', htmlspecialchars(get_option('pingpressfm2_test_title')), '" size="40" /><br /><br />

						Test Link ($link)<br />
						<input type="text" name="pingpressfm2_test_link" value="', htmlspecialchars(get_option('pingpressfm2_test_link')), '" size="40" /><br /><br />
							
						Test Post ($post)<br />
						<textarea name="pingpressfm2_test_post" cols="40" rows="4">', htmlspecialchars(get_option('pingpressfm2_test_post')), '</textarea><br /><br />

						Shortened Link ($slink)<br />
						This plugin uses the service <a href="http://s3nt.com">s3nt</a> for URL shortening. Because of that, you really don\'t need to be able to change this test value.
					</td>
				</tr>
			</table>
			<p>
				<input type="submit" name="Submit" value="', _e('Update Options &raquo;'), '" />
			</p>
		</div>
	</div>
</form>';
}

function pingpressfm2_init($type) {
	add_action('admin_notices', 'pingpressfm2_notices');
}

function pingpressfm2_notices($type) {
	if (get_option('pingpressfm2_firsttime')) {
		if (!get_option('pingpressfm2_api_dev') || !get_option('pingpressfm2_api_user')) {
			echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">You need to configure your pingPressFM plugin. Click <a href="/wp-admin/options-general.php?page=pingPressFM2">here</a> to do that.</div>';
		} else {
			echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">', pingpressfm2_verify(), '</div>';
		}

		update_option('pingpressfm2_firsttime', 0);
	}

	if (get_option('pingpressfm2_options_updated')) {
		if (!get_option('pingpressfm2_api_dev') || !get_option('pingpressfm2_api_user')) {
			echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">Your options have been updated, but you still haven\'t updated your API keys. <a href="http://www.soldoutactivist.com/project-pingpressfm#why-003">How do I get my keys?</a></div>';
		} else {
			if (!get_option('pingpressfm2_verified') || get_option('pingpressfm2_reverify')) {
				echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">', pingpressfm2_verify(), '</div>';
			}
		}

		update_option('pingpressfm2_options_updated', 0);
	}

	$postID = get_option('pingpressfm2_post_published');
	if ($postID) {
		global $wpdb;

		$info_q = 'SELECT * FROM `'. $wpdb->prefix. 'pingpressfm2` WHERE `post_id` = \''. $postID. '\' LIMIT 1';
		$info = mysql_query($info_q);
		if (@mysql_num_rows($info)) {
			$row = @mysql_fetch_assoc($info);

			$row['ping_ids'] = explode(',', $row['ping_ids']);
			$ping_ids = Array();
			$types = Array('s' => 'Status', 'm' => 'Micro-blog', 'b' => 'Blog');
			foreach ($row['ping_ids'] as $ping_id) {
				list($type, $ping, $timestamp) = explode(':', $ping_id);
				if ($timestamp == $row['last_update']) {
					$ping_ids[$types[$type]] = $ping;
				}
			}

			if (!$ping_ids['Status']) {
				$ping_ids['Status'] = '<span style="color: #A00;">FAILED</span>';
			}

			if (!$ping_ids['Micro-blog']) {
				$ping_ids['Micro-blog'] = '<span style="color: #A00;">FAILED</span>';
			}

			if (!$ping_ids['Blog']) {
				$ping_ids['Blog'] = '<span style="color: #A00;">FAILED</span>';
			}

			ksort($ping_ids);

			echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">';
			echo '<strong>pingPressFM:</strong> Response from Ping.fm -- ';
			foreach ($ping_ids as $type => $ping_id) {
				echo $type, ': ', $ping_id;
				echo '&nbsp;&nbsp;&nbsp;';
			}
			echo '</div>';
		} else {
			 echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;"><strong>pingPressFM:</strong> There was an error getting the information from the database...</div>';
		}

		update_option('pingpressfm2_post_published', 0);
	}

	if (get_option('pingpressfm2_test')) {
		$blog_truncate = get_option('pingpressfm2_blog_truncate');
		$separator = get_option('pingpressfm2_dotdotdot');

		$data = Array('title' => get_option('pingpressfm2_test_title'), 'post' => get_option('pingpressfm2_test_post'), 'link' => get_option('pingpressfm2_test_link'), 'slink' => 'http://s3nt.com/aaa', 'separator' => $separator);

		$mb_format = get_option('pingpressfm2_microblog_format');
		$mb_format2 = pingpressfm2_parser($mb_format, $data, 140);

		$s_format = get_option('pingpressfm2_status_format');
		$s_format2 = pingpressfm2_parser($s_format, $data, 200);

		$b_format = get_option('pingpressfm2_blog_format');
		$b_format2 = pingpressfm2_parser($b_format, $data, $blog_truncate);

		echo '<div style="margin: 5px 27px 15px 15px; padding: 10px; background: #AFA; border: 1px #3F3 solid;">';
		echo '<strong>Micro-blog:</strong> ', htmlspecialchars($mb_format), '<br />', $mb_format2, '<br /><br />';
		echo '<strong>Status:</strong> ', htmlspecialchars($s_format), '<br />', $s_format2, '<br /><br />';
		echo '<strong>Blog:</strong> ', htmlspecialchars($b_format), '<br />', nl2br($b_format2);
		echo '</div>';

		update_option('pingpressfm2_test', 0);
	}
}

function pingpressfm2_verify() {
	// do the deed with ping.fm
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_URL, 'http://api.ping.fm/v1/user.validate');
  curl_setopt($ch, CURLOPT_POSTFIELDS, Array('api_key' => get_option('pingpressfm2_api_dev'), 'user_app_key' => get_option('pingpressfm2_api_user')));
  $output = curl_exec($ch);

  // smoke a cigarette afterwards?
  if (preg_match('/OK/', $output)) {
		echo 'Your keys have been verified. Your can now post to your <a href="http://www.ping.fm">Ping.fm</a> account. You may want to check <a href="http://www.soldoutactivist.com/project-pingpressfm#recommended">this guide</a> on how to best set up your Ping.fm account to best utilize this plugin.';
		update_option('pingpressfm2_verified', 1);
  } else {
		echo ('Your key could not be verified. Check your key, or the <a href="http://www.soldoutactivist.com/project-pingpressfm#troubleshooting">troubleshooting guide</a>.');
		update_option('pingpressfm2_verified', 0);
    return false;
  }
	update_option('pingpressfm2_reverify', 0);
}

// set basic functionality hooks
add_action('publish_post', 'pingpressfm2_hook');
add_action('admin_menu', 'pingpressfm2_admin');
add_action('init', 'pingpressfm2_init');

// set up defaults when plugin is activated
register_activation_hook(__FILE__, 'pingpressfm2_install');
